diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/tcp-l4-protocol.h ns-3.36/src/internet/model/tcp-l4-protocol.h
--- ns-3.35/src/internet/model/tcp-l4-protocol.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/tcp-l4-protocol.h	2022-04-30 18:23:57.874733700 -0700
@@ -89,6 +89,10 @@
   TcpL4Protocol ();
   virtual ~TcpL4Protocol ();
 
+  // Delete copy constructor and assignment operator to avoid misuse
+  TcpL4Protocol (const TcpL4Protocol &) = delete;
+  TcpL4Protocol & operator = (const TcpL4Protocol &) = delete;
+
   /**
    * Set node associated with this stack
    * \param node the node
@@ -325,20 +329,6 @@
   IpL4Protocol::DownTargetCallback6 m_downTarget6; //!< Callback to send packets over IPv6
 
   /**
-   * \brief Copy constructor
-   *
-   * Defined and not implemented to avoid misuse
-   */
-  TcpL4Protocol (const TcpL4Protocol &);
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and not implemented to avoid misuse
-   * \returns
-   */
-  TcpL4Protocol &operator = (const TcpL4Protocol &);
-
-  /**
    * \brief Send a packet via TCP (IPv4)
    *
    * \param pkt The packet to send
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/tcp-linux-reno.h ns-3.36/src/internet/model/tcp-linux-reno.h
--- ns-3.35/src/internet/model/tcp-linux-reno.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/tcp-linux-reno.h	2022-04-30 18:23:57.874733700 -0700
@@ -28,6 +28,14 @@
 
 namespace ns3 {
 
+/**
+ * \ingroup congestionOps
+ *
+ * \brief Reno congestion control algorithm
+ * 
+ * This class implement the Reno congestion control type
+ * and it mimics the one implemented in the Linux kernel.
+ */
 class TcpLinuxReno : public TcpCongestionOps
 {
 public:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/tcp-lp.h ns-3.36/src/internet/model/tcp-lp.h
--- ns-3.35/src/internet/model/tcp-lp.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/tcp-lp.h	2022-04-30 18:23:57.874733700 -0700
@@ -32,6 +32,11 @@
 
 class TcpSocketState;
 
+/**
+ * \ingroup congestionOps
+ *
+ * \brief TCP-LP (Low Priority) congestion control algorithm
+ */
 class TcpLp : public TcpNewReno
 {
 public:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/tcp-prr-recovery.cc ns-3.36/src/internet/model/tcp-prr-recovery.cc
--- ns-3.35/src/internet/model/tcp-prr-recovery.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/tcp-prr-recovery.cc	2022-04-30 18:23:57.874733700 -0700
@@ -69,11 +69,11 @@
 }
 
 void
-TcpPrrRecovery::EnterRecovery (Ptr<TcpSocketState> tcb, uint32_t dupAckCount,
+TcpPrrRecovery::EnterRecovery (Ptr<TcpSocketState> tcb, 
+                               [[maybe_unused]] uint32_t dupAckCount,
                                uint32_t unAckDataCount, uint32_t deliveredBytes)
 {
   NS_LOG_FUNCTION (this << tcb << dupAckCount << unAckDataCount);
-  NS_UNUSED (dupAckCount);
 
   m_prrOut = 0;
   m_prrDelivered = 0;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/tcp-recovery-ops.cc ns-3.36/src/internet/model/tcp-recovery-ops.cc
--- ns-3.35/src/internet/model/tcp-recovery-ops.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/tcp-recovery-ops.cc	2022-04-30 18:23:57.874733700 -0700
@@ -95,20 +95,18 @@
 
 void
 TcpClassicRecovery::EnterRecovery (Ptr<TcpSocketState> tcb, uint32_t dupAckCount,
-                                   uint32_t unAckDataCount, uint32_t deliveredBytes)
+                                   [[maybe_unused]] uint32_t unAckDataCount, 
+                                   [[maybe_unused]] uint32_t deliveredBytes)
 {
   NS_LOG_FUNCTION (this << tcb << dupAckCount << unAckDataCount);
-  NS_UNUSED (unAckDataCount);
-  NS_UNUSED (deliveredBytes);
   tcb->m_cWnd = tcb->m_ssThresh;
   tcb->m_cWndInfl = tcb->m_ssThresh + (dupAckCount * tcb->m_segmentSize);
 }
 
 void
-TcpClassicRecovery::DoRecovery (Ptr<TcpSocketState> tcb, uint32_t deliveredBytes)
+TcpClassicRecovery::DoRecovery (Ptr<TcpSocketState> tcb, [[maybe_unused]] uint32_t deliveredBytes)
 {
   NS_LOG_FUNCTION (this << tcb << deliveredBytes);
-  NS_UNUSED (deliveredBytes);
   tcb->m_cWndInfl += tcb->m_segmentSize;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/tcp-socket-base.cc ns-3.36/src/internet/model/tcp-socket-base.cc
--- ns-3.35/src/internet/model/tcp-socket-base.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/tcp-socket-base.cc	2022-04-30 18:23:57.874733700 -0700
@@ -860,9 +860,8 @@
 
 /* Inherit from Socket class: In TcpSocketBase, it is same as Send() call */
 int
-TcpSocketBase::SendTo (Ptr<Packet> p, uint32_t flags, const Address &address)
+TcpSocketBase::SendTo (Ptr<Packet> p, uint32_t flags, [[maybe_unused]] const Address &address)
 {
-  NS_UNUSED (address);
   return Send (p, flags); // SendTo() and Send() are the same
 }
 
@@ -2304,9 +2303,9 @@
 /* Received a packet upon SYN_RCVD */
 void
 TcpSocketBase::ProcessSynRcvd (Ptr<Packet> packet, const TcpHeader& tcpHeader,
-                               const Address& fromAddress, const Address& toAddress)
+                               const Address& fromAddress, 
+                               [[maybe_unused]] const Address& toAddress)
 {
-  NS_UNUSED (toAddress);
   NS_LOG_FUNCTION (this << tcpHeader);
 
   // Extract the flags. PSH, URG, CWR and ECE are disregarded.
@@ -2886,11 +2885,10 @@
    TcpSocketBase cloned, allocate a new end point to handle the incoming
    connection and send a SYN+ACK to complete the handshake. */
 void
-TcpSocketBase::CompleteFork (Ptr<Packet> p, const TcpHeader& h,
+TcpSocketBase::CompleteFork ([[maybe_unused]] Ptr<Packet> p, const TcpHeader& h,
                              const Address& fromAddress, const Address& toAddress)
 {
   NS_LOG_FUNCTION (this << p << h << fromAddress << toAddress);
-  NS_UNUSED (p);
   // Get port and address from peer (connecting host)
   if (InetSocketAddress::IsMatchingType (toAddress))
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/tcp-tx-buffer.cc ns-3.36/src/internet/model/tcp-tx-buffer.cc
--- ns-3.35/src/internet/model/tcp-tx-buffer.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/tcp-tx-buffer.cc	2022-04-30 18:23:57.874733700 -0700
@@ -686,9 +686,8 @@
       if (i == m_sentList.end ())
         {
           // Move data from app list to sent list, so we can delete the item
-          Ptr<Packet> p = CopyFromSequence (offset, m_firstByteSeq)->GetPacketCopy ();
+          [[maybe_unused]] Ptr<Packet> p = CopyFromSequence (offset, m_firstByteSeq)->GetPacketCopy ();
           NS_ASSERT (p != nullptr);
-          NS_UNUSED (p);
           i = m_sentList.begin ();
           NS_ASSERT (i != m_sentList.end ());
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/tcp-westwood.cc ns-3.36/src/internet/model/tcp-westwood.cc
--- ns-3.35/src/internet/model/tcp-westwood.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/tcp-westwood.cc	2022-04-30 18:23:57.878733600 -0700
@@ -59,7 +59,7 @@
                   MakeEnumChecker(TcpWestwood::WESTWOOD, "Westwood",TcpWestwood::WESTWOODPLUS, "WestwoodPlus"))
     .AddTraceSource("EstimatedBW", "The estimated bandwidth",
                     MakeTraceSourceAccessor(&TcpWestwood::m_currentBW),
-                    "ns3::TracedValueCallback::Double")
+                    "ns3::TracedValueCallback::DataRate")
   ;
   return tid;
 }
@@ -130,34 +130,34 @@
 
   NS_ASSERT (!rtt.IsZero ());
 
-  m_currentBW = m_ackedSegments * tcb->m_segmentSize / rtt.GetSeconds ();
-
   if (m_pType == TcpWestwood::WESTWOOD)
     {
       Time currentAck = Simulator::Now ();
-      m_currentBW = m_ackedSegments * tcb->m_segmentSize / (currentAck - m_lastAck).GetSeconds ();
+
+      NS_ABORT_MSG_IF (currentAck == m_lastAck,
+        "This violates a model assumption and would lead to divide-by-zero; please report to ns-3 maintainers if this occurs.");
+
+      m_currentBW = DataRate (m_ackedSegments * tcb->m_segmentSize * 8.0 / (currentAck - m_lastAck).GetSeconds ());
       m_lastAck = currentAck;
     }
   else if (m_pType == TcpWestwood::WESTWOODPLUS)
     {
-      m_currentBW = m_ackedSegments * tcb->m_segmentSize / rtt.GetSeconds ();
+      m_currentBW = DataRate (m_ackedSegments * tcb->m_segmentSize * 8.0 / rtt.GetSeconds ());
       m_IsCount = false;
     }
 
   m_ackedSegments = 0;
+
   NS_LOG_LOGIC ("Estimated BW: " << m_currentBW);
 
   // Filter the BW sample
 
-  double alpha = 0.9;
+  constexpr double alpha = 0.9;
 
-  if (m_fType == TcpWestwood::NONE)
+  if (m_fType == TcpWestwood::TUSTIN)
     {
-    }
-  else if (m_fType == TcpWestwood::TUSTIN)
-    {
-      double sample_bwe = m_currentBW;
-      m_currentBW = (alpha * m_lastBW) + ((1 - alpha) * ((sample_bwe + m_lastSampleBW) / 2));
+      DataRate sample_bwe = m_currentBW;
+      m_currentBW = (m_lastBW * alpha) + (((sample_bwe + m_lastSampleBW) * 0.5) * (1 - alpha));
       m_lastSampleBW = sample_bwe;
       m_lastBW = m_currentBW;
     }
@@ -167,15 +167,15 @@
 
 uint32_t
 TcpWestwood::GetSsThresh (Ptr<const TcpSocketState> tcb,
-                          uint32_t bytesInFlight)
+                          [[maybe_unused]] uint32_t bytesInFlight)
 {
-  NS_UNUSED (bytesInFlight);
-  NS_LOG_LOGIC ("CurrentBW: " << m_currentBW << " minRtt: " <<
-                tcb->m_minRtt << " ssthresh: " <<
-                m_currentBW * static_cast<double> (tcb->m_minRtt.GetSeconds ()));
+  uint32_t ssThresh = static_cast<uint32_t> ((m_currentBW * tcb->m_minRtt) / 8.0);
+
+  NS_LOG_LOGIC ("CurrentBW: " << m_currentBW <<
+                " minRtt: " << tcb->m_minRtt <<
+                " ssThresh: " << ssThresh);
 
-  return std::max (2*tcb->m_segmentSize,
-                   uint32_t (m_currentBW * static_cast<double> (tcb->m_minRtt.GetSeconds ())));
+  return std::max (2 * tcb->m_segmentSize, ssThresh);
 }
 
 Ptr<TcpCongestionOps>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/tcp-westwood.h ns-3.36/src/internet/model/tcp-westwood.h
--- ns-3.35/src/internet/model/tcp-westwood.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/tcp-westwood.h	2022-04-30 18:23:57.878733600 -0700
@@ -34,17 +34,14 @@
 #define TCP_WESTWOOD_H
 
 #include "tcp-congestion-ops.h"
+#include "ns3/data-rate.h"
 #include "ns3/tcp-recovery-ops.h"
-#include "ns3/sequence-number.h"
 #include "ns3/traced-value.h"
 #include "ns3/event-id.h"
 
 namespace ns3 {
 
-class Packet;
-class TcpHeader;
 class Time;
-class EventId;
 
 /**
  * \ingroup congestionOps
@@ -63,6 +60,8 @@
  * the number of acknowledged segments on the receipt of an ACK.
  * The EstimateBW estimates the bandwidth based on the value returned by CountAck
  * and the sampling interval (last ACK inter-arrival time for Westwood and last RTT for Westwood+).
+ *
+ * WARNING: this TCP model lacks validation and regression tests; use with caution.
  */
 class TcpWestwood : public TcpNewReno
 {
@@ -124,9 +123,9 @@
   void EstimateBW (const Time& rtt, Ptr<TcpSocketState> tcb);
 
 protected:
-  TracedValue<double>    m_currentBW;              //!< Current value of the estimated BW
-  double                 m_lastSampleBW;           //!< Last bandwidth sample
-  double                 m_lastBW;                 //!< Last bandwidth sample after being filtered
+  TracedValue<DataRate>  m_currentBW;              //!< Current value of the estimated BW
+  DataRate               m_lastSampleBW;           //!< Last bandwidth sample
+  DataRate               m_lastBW;                 //!< Last bandwidth sample after being filtered
   enum ProtocolType      m_pType;                  //!< 0 for Westwood, 1 for Westwood+
   enum FilterType        m_fType;                  //!< 0 for none, 1 for Tustin
 
@@ -134,7 +133,6 @@
   bool                   m_IsCount;                //!< Start keeping track of m_ackedSegments for Westwood+ if TRUE
   EventId                m_bwEstimateEvent;        //!< The BW estimation event for Westwood+
   Time                   m_lastAck;                //!< The last ACK time
-
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/model/udp-l4-protocol.h ns-3.36/src/internet/model/udp-l4-protocol.h
--- ns-3.35/src/internet/model/udp-l4-protocol.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/model/udp-l4-protocol.h	2022-04-30 18:23:57.878733600 -0700
@@ -70,6 +70,10 @@
   UdpL4Protocol ();
   virtual ~UdpL4Protocol ();
 
+  // Delete copy constructor and assignment operator to avoid misuse
+  UdpL4Protocol (const UdpL4Protocol &) = delete;
+  UdpL4Protocol &operator = (const UdpL4Protocol &) = delete;
+
   /**
    * Set node associated with this stack
    * \param node the node
@@ -257,20 +261,6 @@
   Ipv4EndPointDemux *m_endPoints; //!< A list of IPv4 end points.
   Ipv6EndPointDemux *m_endPoints6; //!< A list of IPv6 end points.
 
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and not implemented to avoid misuse
-   */
-  UdpL4Protocol (const UdpL4Protocol &);
-  /**
-   * \brief Copy constructor
-   *
-   * Defined and not implemented to avoid misuse
-   * \returns
-   */
-  UdpL4Protocol &operator = (const UdpL4Protocol &);
-
   std::vector<Ptr<UdpSocketImpl> > m_sockets;      //!< list of sockets
   IpL4Protocol::DownTargetCallback m_downTarget;   //!< Callback to send packets over IPv4
   IpL4Protocol::DownTargetCallback6 m_downTarget6; //!< Callback to send packets over IPv6
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/test/global-route-manager-impl-test-suite.cc ns-3.36/src/internet/test/global-route-manager-impl-test-suite.cc
--- ns-3.35/src/internet/test/global-route-manager-impl-test-suite.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/test/global-route-manager-impl-test-suite.cc	2022-04-30 18:23:57.878733600 -0700
@@ -201,7 +201,7 @@
   srmlsdb->Insert (lsa1->GetLinkStateId (), lsa1);
   srmlsdb->Insert (lsa2->GetLinkStateId (), lsa2);
   srmlsdb->Insert (lsa3->GetLinkStateId (), lsa3);
-  NS_ASSERT (lsa2 == srmlsdb->GetLSA (lsa2->GetLinkStateId ()));
+  NS_TEST_ASSERT_MSG_EQ (lsa2, srmlsdb->GetLSA (lsa2->GetLinkStateId ()), "The Ipv4Address is not stored as the link state ID");
 
   // next, calculate routes based on the manually created LSDB
   GlobalRouteManagerImpl* srm = new GlobalRouteManagerImpl ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/test/icmp-test.cc ns-3.36/src/internet/test/icmp-test.cc
--- ns-3.35/src/internet/test/icmp-test.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/test/icmp-test.cc	2022-04-30 18:23:57.878733600 -0700
@@ -435,7 +435,7 @@
 {
   Address from;
   Ptr<Packet> p = socket->RecvFrom (from);
-  m_receivedPacket = p->Copy ();
+  Ptr<Packet> pkt = p->Copy ();
 
   if (Inet6SocketAddress::IsMatchingType (from))
     {
@@ -448,12 +448,9 @@
       Icmpv6Header icmpv6;
       p->RemoveHeader (icmpv6);
 
-      // Ignore the neighbor discovery (ICMPV6_ND) packets
-      if (!(((int)icmpv6.GetType () >= 133) && ((int)icmpv6.GetType () <= 137)))
+      if (icmpv6.GetType () == Icmpv6Header::ICMPV6_ECHO_REPLY)
         {
-          NS_TEST_EXPECT_MSG_EQ ((int) icmpv6.GetType (),
-                                 Icmpv6Header::ICMPV6_ECHO_REPLY,
-                                 "The received Packet is not a ICMPV6_ECHO_REPLY");
+          m_receivedPacket = pkt->Copy ();
         }
     }
 }
@@ -502,7 +499,7 @@
                                   &IcmpV6EchoReplyTestCase::SendData, this, socket, i.GetAddress (1,1));
   Simulator::Run ();
 
-  NS_TEST_EXPECT_MSG_EQ (m_receivedPacket->GetSize (), 72, " Unexpected ICMPV6_ECHO_REPLY packet size");
+  NS_TEST_EXPECT_MSG_EQ (m_receivedPacket->GetSize (), 52, " Unexpected ICMPV6_ECHO_REPLY packet size");
 
   Simulator::Destroy ();
 }
@@ -579,7 +576,7 @@
 {
   Address from;
   Ptr<Packet> p = socket->RecvFrom (from);
-  m_receivedPacket = p->Copy ();
+  Ptr<Packet> pkt = p->Copy ();
 
   if (Inet6SocketAddress::IsMatchingType (from))
     {
@@ -594,12 +591,10 @@
       Icmpv6Header icmpv6;
       p->RemoveHeader (icmpv6);
 
-      // Ignore the neighbor discovery (ICMPV6_ND) packets
-      if (!(((int)icmpv6.GetType () >= 133) && ((int)icmpv6.GetType () <= 137)))
+      // Ignore any packet except ICMPV6_ERROR_TIME_EXCEEDED
+      if (icmpv6.GetType () == Icmpv6Header::ICMPV6_ERROR_TIME_EXCEEDED)
         {
-          NS_TEST_EXPECT_MSG_EQ ((int) icmpv6.GetType (),
-                                 Icmpv6Header::ICMPV6_ERROR_TIME_EXCEEDED,
-                                 "The received Packet is not a ICMPV6_ERROR_TIME_EXCEEDED");
+          m_receivedPacket = pkt->Copy ();
         }
     }
 }
@@ -663,7 +658,7 @@
                                   &IcmpV6TimeExceedTestCase::SendData, this, socket, interfaces2.GetAddress (1,1));
   Simulator::Run ();
 
-  NS_TEST_EXPECT_MSG_EQ (m_receivedPacket->GetSize (), 72, " Unexpected ICMPV6_ECHO_REPLY packet size");
+  NS_TEST_EXPECT_MSG_EQ (m_receivedPacket->GetSize (), 100, " Unexpected ICMPV6_ECHO_REPLY packet size");
 
   Simulator::Destroy ();
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/test/ipv4-deduplication-test.cc ns-3.36/src/internet/test/ipv4-deduplication-test.cc
--- ns-3.35/src/internet/test/ipv4-deduplication-test.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/test/ipv4-deduplication-test.cc	2022-04-30 18:23:57.878733600 -0700
@@ -199,7 +199,7 @@
   uint32_t availableData;
   availableData = socket->GetRxAvailable ();
   Ptr<Packet> packet = socket->Recv (std::numeric_limits<uint32_t>::max (), 0);
-  NS_ASSERT (availableData == packet->GetSize ());
+  NS_TEST_ASSERT_MSG_EQ (availableData, packet->GetSize (), "Received packet size is not equal to the Rx buffer size");
 
   auto node = socket->GetNode ();
   std::string name = Names::FindName (node);
@@ -339,7 +339,7 @@
       //// many Unix variants.
       //// So, we just log it and fall through to LookupStatic ()
       auto ipv4 = (*iter)->GetObject <Ipv4> ();
-      NS_ASSERT_MSG ((bool) ipv4, "Node " << Names::FindName (*iter) << " does not have Ipv4 aggregate");
+      NS_TEST_ASSERT_MSG_EQ ((bool) ipv4, true, "Node " << Names::FindName (*iter) << " does not have Ipv4 aggregate");
       auto routing = staticRouting.GetStaticRouting (ipv4);
       routing->AddHostRouteTo (targetAddr.c_str (), ipv4->GetInterfaceForDevice (*diter), 0);
 
@@ -615,7 +615,7 @@
       //// many Unix variants.
       //// So, we just log it and fall through to LookupStatic ()
       auto ipv4 = (*iter)->GetObject <Ipv4> ();
-      NS_ASSERT_MSG ((bool) ipv4, "Node " << (*iter)->GetId () << " does not have Ipv4 aggregate");
+      NS_TEST_ASSERT_MSG_EQ ((bool) ipv4, true, "Node " << (*iter)->GetId () << " does not have Ipv4 aggregate");
       auto routing = staticRouting.GetStaticRouting (ipv4);
       routing->AddHostRouteTo (targetAddr.c_str (), ipv4->GetInterfaceForDevice (*diter), 0);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/test/ipv4-forwarding-test.cc ns-3.36/src/internet/test/ipv4-forwarding-test.cc
--- ns-3.35/src/internet/test/ipv4-forwarding-test.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/test/ipv4-forwarding-test.cc	2022-04-30 18:23:57.878733600 -0700
@@ -91,7 +91,7 @@
   uint32_t availableData;
   availableData = socket->GetRxAvailable ();
   m_receivedPacket = socket->Recv (std::numeric_limits<uint32_t>::max (), 0);
-  NS_ASSERT (availableData == m_receivedPacket->GetSize ());
+  NS_TEST_ASSERT_MSG_EQ (availableData, m_receivedPacket->GetSize (), "Received packet size is not equal to Rx buffer size");
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/test/ipv4-global-routing-test-suite.cc ns-3.36/src/internet/test/ipv4-global-routing-test-suite.cc
--- ns-3.35/src/internet/test/ipv4-global-routing-test-suite.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/test/ipv4-global-routing-test-suite.cc	2022-04-30 18:23:57.878733600 -0700
@@ -1139,7 +1139,7 @@
   uint32_t availableData;
   availableData = socket->GetRxAvailable ();
   m_receivedPacket = socket->Recv (std::numeric_limits<uint32_t>::max (), 0);
-  NS_ASSERT (availableData == m_receivedPacket->GetSize ());
+  NS_TEST_ASSERT_MSG_EQ (availableData, m_receivedPacket->GetSize (), "Received packet size is not equal to Rx buffer size");
   //cast availableData to void, to suppress 'availableData' set but not used
   //compiler warning
   (void) availableData;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/test/ipv4-header-test.cc ns-3.36/src/internet/test/ipv4-header-test.cc
--- ns-3.35/src/internet/test/ipv4-header-test.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/test/ipv4-header-test.cc	2022-04-30 18:23:57.878733600 -0700
@@ -113,9 +113,9 @@
   uint32_t availableData;
   availableData = socket->GetRxAvailable ();
   m_receivedPacket = socket->Recv (2, MSG_PEEK);
-  NS_ASSERT (m_receivedPacket->GetSize () == 2);
+  NS_TEST_ASSERT_MSG_EQ (m_receivedPacket->GetSize (),2, "Received packet size is  not equal to 2");
   m_receivedPacket = socket->Recv (std::numeric_limits<uint32_t>::max (), 0);
-  NS_ASSERT (availableData == m_receivedPacket->GetSize ());
+  NS_TEST_ASSERT_MSG_EQ (availableData, m_receivedPacket->GetSize (), "Received packet size is not equal to Rx buffer size");
   m_receivedPacket->PeekHeader (m_receivedHeader);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/test/ipv4-raw-test.cc ns-3.36/src/internet/test/ipv4-raw-test.cc
--- ns-3.35/src/internet/test/ipv4-raw-test.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/test/ipv4-raw-test.cc	2022-04-30 18:23:57.878733600 -0700
@@ -138,9 +138,9 @@
   uint32_t availableData;
   availableData = socket->GetRxAvailable ();
   m_receivedPacket = socket->Recv (2, MSG_PEEK);
-  NS_ASSERT (m_receivedPacket->GetSize () == 2);
+  NS_TEST_ASSERT_MSG_EQ (m_receivedPacket->GetSize (), 2, "ReceivedPacket size is not equal to 2");
   m_receivedPacket = socket->Recv (std::numeric_limits<uint32_t>::max (), 0);
-  NS_ASSERT (availableData == m_receivedPacket->GetSize ());
+  NS_TEST_ASSERT_MSG_EQ (availableData, m_receivedPacket->GetSize (), "Received packet size is not equal to Rx buffer size");
 }
 
 void Ipv4RawSocketImplTest::ReceivePkt2 (Ptr<Socket> socket)
@@ -148,9 +148,9 @@
   uint32_t availableData;
   availableData = socket->GetRxAvailable ();
   m_receivedPacket2 = socket->Recv (2, MSG_PEEK);
-  NS_ASSERT (m_receivedPacket2->GetSize () == 2);
+  NS_TEST_ASSERT_MSG_EQ (m_receivedPacket2->GetSize (), 2, "ReceivedPacket size is not equal to 2");
   m_receivedPacket2 = socket->Recv (std::numeric_limits<uint32_t>::max (), 0);
-  NS_ASSERT (availableData == m_receivedPacket2->GetSize ());
+  NS_TEST_ASSERT_MSG_EQ (availableData, m_receivedPacket2->GetSize (), "Received packet size is not equal to Rx buffer size");
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/test/ipv4-rip-test.cc ns-3.36/src/internet/test/ipv4-rip-test.cc
--- ns-3.35/src/internet/test/ipv4-rip-test.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/test/ipv4-rip-test.cc	2022-04-30 18:23:57.878733600 -0700
@@ -91,7 +91,7 @@
   uint32_t availableData;
   availableData = socket->GetRxAvailable ();
   m_receivedPacket = socket->Recv (std::numeric_limits<uint32_t>::max (), 0);
-  NS_ASSERT (availableData == m_receivedPacket->GetSize ());
+  NS_TEST_ASSERT_MSG_EQ (availableData, m_receivedPacket->GetSize (), "Received Packet size is not equal to the Rx buffer size");
   //cast availableData to void, to suppress 'availableData' set but not used
   //compiler warning
   (void) availableData;
@@ -313,7 +313,7 @@
   uint32_t availableData;
   availableData = socket->GetRxAvailable ();
   m_receivedPacket = socket->Recv (std::numeric_limits<uint32_t>::max (), 0);
-  NS_ASSERT (availableData == m_receivedPacket->GetSize ());
+  NS_TEST_ASSERT_MSG_EQ (availableData, m_receivedPacket->GetSize (), "Received Packet size is not equal to the Rx buffer size");
   //cast availableData to void, to suppress 'availableData' set but not used
   //compiler warning
   (void) availableData;
@@ -535,7 +535,7 @@
   availableData = socket->GetRxAvailable ();
   Address srcAddr;
   Ptr<Packet> receivedPacketProbe = socket->RecvFrom (std::numeric_limits<uint32_t>::max (), 0, srcAddr);
-  NS_ASSERT (availableData == receivedPacketProbe->GetSize ());
+  NS_TEST_ASSERT_MSG_EQ (availableData, receivedPacketProbe->GetSize (), "Received Packet size is not equal to the Rx buffer size");
   Ipv4Address senderAddress = InetSocketAddress::ConvertFrom (srcAddr).GetIpv4 ();
 
   if (senderAddress == "192.168.0.2")
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/test/ipv4-static-routing-test-suite.cc ns-3.36/src/internet/test/ipv4-static-routing-test-suite.cc
--- ns-3.35/src/internet/test/ipv4-static-routing-test-suite.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/test/ipv4-static-routing-test-suite.cc	2022-04-30 18:23:57.878733600 -0700
@@ -91,7 +91,7 @@
   uint32_t availableData;
   availableData = socket->GetRxAvailable ();
   m_receivedPacket = socket->Recv (std::numeric_limits<uint32_t>::max (), 0);
-  NS_ASSERT (availableData == m_receivedPacket->GetSize ());
+  NS_TEST_ASSERT_MSG_EQ (availableData, m_receivedPacket->GetSize (), "Received packet size is not equal to Rx buffer size");
   //cast availableData to void, to suppress 'availableData' set but not used
   //compiler warning
   (void) availableData;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/test/ipv6-forwarding-test.cc ns-3.36/src/internet/test/ipv6-forwarding-test.cc
--- ns-3.35/src/internet/test/ipv6-forwarding-test.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/test/ipv6-forwarding-test.cc	2022-04-30 18:23:57.878733600 -0700
@@ -89,7 +89,7 @@
   uint32_t availableData;
   availableData = socket->GetRxAvailable ();
   m_receivedPacket = socket->Recv (std::numeric_limits<uint32_t>::max (), 0);
-  NS_ASSERT (availableData == m_receivedPacket->GetSize ());
+  NS_TEST_ASSERT_MSG_EQ (availableData, m_receivedPacket->GetSize (), "Received packet size is not equal to Rx buffer size");
   //cast availableData to void, to suppress 'availableData' set but not used
   //compiler warning
   (void) availableData;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/test/ipv6-fragmentation-test.cc ns-3.36/src/internet/test/ipv6-fragmentation-test.cc
--- ns-3.35/src/internet/test/ipv6-fragmentation-test.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/test/ipv6-fragmentation-test.cc	2022-04-30 18:23:57.878733600 -0700
@@ -176,6 +176,26 @@
    * \returns The sent packet.
    */
   Ptr<Packet> SendClient (void);
+
+  /**
+   * \brief Handle Server's incoming packets.
+   * Ensure no packet greater than MTU is received
+   *
+   * \param packet the packet.
+   * \param ipv6 the Ipv6 protocol.
+   * \param interface the IP-level interface index.
+   */
+  void HandleServerRx (Ptr<const Packet> packet, Ptr<Ipv6> ipv6, uint32_t interface);
+
+  /**
+   * \brief Handle Client's transmitting packets.
+   * Ensure no packet greater than MTU is transmitted
+   *
+   * \param packet the packet.
+   * \param ipv6 the Ipv6 protocol.
+   * \param interface the IP-level interface index.
+   */
+  void HandleClientTx (Ptr<const Packet> packet, Ptr<Ipv6> ipv6, uint32_t interface);
 };
 
 
@@ -320,6 +340,16 @@
   return p;
 }
 
+void Ipv6FragmentationTest::HandleServerRx (Ptr<const Packet> packet, Ptr<Ipv6> ipv6, uint32_t interface)
+{
+  NS_TEST_EXPECT_MSG_LT_OR_EQ (packet->GetSize (), ipv6->GetMtu (interface), "Received packet size > MTU: packetSizes: " << packet->GetSize ());
+}
+
+void Ipv6FragmentationTest::HandleClientTx (Ptr<const Packet> packet, Ptr<Ipv6> ipv6, uint32_t interface)
+{
+  NS_TEST_EXPECT_MSG_LT_OR_EQ (packet->GetSize (), ipv6->GetMtu (interface), "Transmitted packet size > MTU: packetSizes: " << packet->GetSize ());
+}
+
 void
 Ipv6FragmentationTest::DoRun (void)
 {
@@ -345,6 +375,7 @@
     Ipv6InterfaceAddress ipv6Addr = Ipv6InterfaceAddress (Ipv6Address ("2001::1"), Ipv6Prefix (32));
     ipv6->AddAddress (netdev_idx, ipv6Addr);
     ipv6->SetUp (netdev_idx);
+    ipv6->TraceConnectWithoutContext ("Rx", MakeCallback (&Ipv6FragmentationTest::HandleServerRx, this));
   }
   StartServer (serverNode);
 
@@ -365,6 +396,7 @@
     Ipv6InterfaceAddress ipv6Addr = Ipv6InterfaceAddress (Ipv6Address ("2001::2"), Ipv6Prefix (32));
     ipv6->AddAddress (netdev_idx, ipv6Addr);
     ipv6->SetUp (netdev_idx);
+    ipv6->TraceConnectWithoutContext ("Tx", MakeCallback (&Ipv6FragmentationTest::HandleClientTx, this));
   }
   StartClient (clientNode);
 
@@ -376,7 +408,7 @@
 
 
   // some small packets, some rather big ones
-  uint32_t packetSizes[5] = {2000, 2500, 5000, 10000, 65000};
+  uint32_t packetSizes[5] = {1500, 2000, 5000, 10000, 65000};
 
   // using the alphabet
   uint8_t fillData[78];
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/internet/test/ipv6-raw-test.cc ns-3.36/src/internet/test/ipv6-raw-test.cc
--- ns-3.35/src/internet/test/ipv6-raw-test.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/internet/test/ipv6-raw-test.cc	2022-04-30 18:23:57.878733600 -0700
@@ -127,9 +127,9 @@
   uint32_t availableData;
   availableData = socket->GetRxAvailable ();
   m_receivedPacket = socket->Recv (2, MSG_PEEK);
-  NS_ASSERT (m_receivedPacket->GetSize () == 2);
+  NS_TEST_ASSERT_MSG_EQ (m_receivedPacket->GetSize (), 2, "ReceivedPacket size is not equal to 2");
   m_receivedPacket = socket->Recv (std::numeric_limits<uint32_t>::max (), 0);
-  NS_ASSERT (availableData == m_receivedPacket->GetSize ());
+  NS_TEST_ASSERT_MSG_EQ (availableData, m_receivedPacket->GetSize (), "Received packet size is not equal to Rx buffer size");
 }
 
 void Ipv6RawSocketImplTest::ReceivePkt2 (Ptr<Socket> socket)
@@ -138,9 +138,9 @@
   Address addr;
   availableData = socket->GetRxAvailable ();
   m_receivedPacket2 = socket->Recv (2, MSG_PEEK);
-  NS_ASSERT (m_receivedPacket2->GetSize () == 2);
+  NS_TEST_ASSERT_MSG_EQ (m_receivedPacket2->GetSize (), 2, "ReceivedPacket size is not equal to 2");
   m_receivedPacket2 = socket->RecvFrom (std::numeric_limits<uint32_t>::max (), 0, addr);
-  NS_ASSERT (availableData == m_receivedPacket2->GetSize ());
+  NS_TEST_ASSERT_MSG_EQ (availableData, m_receivedPacket2->GetSize (), "Received packet size is not equal to Rx buffer size");
   Inet6SocketAddress v6addr = Inet6SocketAddress::ConvertFrom (addr);
   NS_TEST_EXPECT_MSG_EQ (v6addr.GetIpv6 (), Ipv6Address ("2001:db8::2"), "recvfrom");
 }
